//Fortran: EQUIVALENCE ( ... )
Unit SF53R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF49R_p;

function SF53R(Y :Real; Z :Real; EPS :Real): Real;

implementation

function SF53R(Y :Real; Z :Real; EPS :Real): Real;
var
EP1,T,B,A,TA,C,HSQB,EXPOV,ASQ,A4,B4,A4B4,AHSQB,AB4,F,SUM,G,G1,BER,TER,
   D1,D2,AEPS,D,BEXP :Real;
const
SYS076 :Real = 8.872283E+01;
SYS017 :Real = 0.15915494309189533576888376337251;
label
_1,_2,_3,_4,_5,_6;
begin
{ Result -    SF53R  FORTRANe }
EXPOV := SYS076;   //  EQUIVALENCE
C := SYS017;      //  EQUIVALENCE
EP1 := EPS;
if ( EPS = 0.0 ) 
 then EP1 := 0.000001;
T := 0.0;
B := Abs(Y);
A := Abs(Z);
if ( A = 0.0 ) 
 then goto _6;
TA := ArcTan(A);
if ( A*B <= 4.0 ) 
 then goto _1;
T := SF49R(B);
T := C*(TA+ArcTan(1.0/A))-0.5*(T-0.5);
goto _5;
_1:
HSQB := 0.5*B*B;
if ( HSQB > EXPOV ) 
 then goto _6;
BEXP := Exp(-HSQB);
ASQ := A*A;
A4 := ASQ*ASQ;
B4 := HSQB*HSQB;
A4B4 := A4*B4;
AHSQB := A*HSQB;
AB4 := A*B4*0.5;
F := 1.0;
SUM := 0.0;
G := 3.0;
_2:
G1 := G;
BER := 0.0;
TER := AB4;
_3:
BER := BER+TER;
if ( TER <= BER*EP1 ) 
 then goto _4;
TER := TER*HSQB/G1;
G1 := G1+1.0;
goto _3;
_4:
D1 := (BER+AHSQB)/F;
D2 := BER*ASQ/(F+2.0);
D := D1-D2;
SUM := SUM+D;
T := TA-SUM*BEXP;
AEPS := EP1*T;
AHSQB := AHSQB*A4B4/((G-1.0)*G);
AB4 := AB4*A4B4/((G+1.0)*G);
F := F+4.0;
G := G+2.0;
if ( D2*BEXP >= AEPS ) 
 then goto _2;
T := T*C;
_5:
if ( Z < 0.0 ) 
 then T := -T;
_6:
Result := T;
exit;
end;

end.
