Unit SF54R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF14_p, SF49R_p, SF35R_p, SF53R_p;

function SF54R(X :Real; D :Real; IDF :Integer;
                var IERR :Integer): Real;

implementation

function SF54R(X :Real; D :Real; IDF :Integer;
                var IERR :Integer): Real;
var
L,I1,IDFM2 :Integer;
DF,TVAL,A,B,SB,DA,DSB,DASB,P1,F2,F1,SUM,AZ,FZ,FKM1,P :Real;
const
C :Real = 1.591549E-01;
A2 :Real = 1.591549E-01;
A3 :Real = 2.506628E0;
A1 :Real = 3.989423E-01;
SYS089 :Real = 1.0E-6;
SYS059 :Real = 3.4E38;
SYS029 :Real = 0.70710678118654752440084436210485;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
IERR := 0;  // 
{ Result -    SF54R  FORTRANe }
if ( IDF <= 0 ) 
 then goto _11;
DF := IDF;
TVAL := X;
I1 := IDF-2*(IDF div 2);
A := TVAL/Sqrt(DF);
B := DF/(DF+TVAL*TVAL);
SB := Sqrt(B);
DA := D*A;
DSB := D*SB;
DASB := A*DSB;
P1 := SF49R(DASB);
F2 := A*SB*Exp(-0.5*DSB*DSB)*P1*A1;
F1 := B*(DA*F2+A*A2*Exp(-0.5*D*D));
SUM := 0.0;
if ( IDF = 1 ) 
 then goto _9;
if ( I1 ) < 0
 then goto _1
 else if ( I1 ) > 0
       then goto _2
       else goto _1;
_1:
SUM := F2;
goto _3;
_2:
SUM := F1;
_3:
if ( IDF < 4 ) 
 then goto _8;
IDFM2 := IDF-2;
AZ := 1.0;
FZ := 2.0;
L := 2;
while ( L<=IDFM2 ) do
 begin
  FKM1 := FZ-1.0;
  F2 := B*(DA*AZ*F1+F2)*FKM1/FZ;
  AZ := 1.0/(AZ*FKM1);
  F1 := B*(DA*AZ*F2+F1)*FZ/(FZ+1.0);
  if ( I1 ) < 0
   then goto _4
   else if ( I1 ) > 0
         then goto _5
         else goto _4;
_4:
  SUM := SUM+F2;
  goto _6;
_5:
  SUM := SUM+F1;
_6:
  AZ := 1.0/(AZ*FZ);
  FZ := FZ+2.0;
_7:
  inc(L,2);
 end;
_8:
if ( I1 ) < 0
 then goto _10
 else if ( I1 ) > 0
       then goto _9
       else goto _10;
_9:
P1 := 0.5*SF35R(SYS029*DSB);
P := SF53R(DSB,A,SYS089);
Result := P1+2.0*(P+SUM);
goto _12;
_10:
P1 := 0.5*SF35R(SYS029*D);
Result := P1+SUM*A3;
goto _12;
_11:
IERR := 65;
Result := SYS059;
UTSF14(IERR,54);
_12:
exit;
end;

end.
